--- linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/cncfb.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/cncfb.h	2014-12-04 11:15:33.692449000 +0800
@@ -0,0 +1,83 @@
+/*
+ *  linux/drivers/video/celestial/cncfb.h -- celestial frame buffer device
+ *
+ *  Copyright (C) 2010 Celestial Semiconductor
+ *  Copyright (C) 2011 Cavium
+ *
+ *  This file is subject to the terms and conditions of the GNU General Public
+ *  License. See the file COPYING in the main directory of this archive for
+ *  more details.
+ */
+
+
+#ifndef __CSMFB_DEV_H__
+#define __CSMFB_DEV_H__
+
+typedef struct _gfx_colorkey {
+	char r_min;
+	char r_max;
+
+	char g_min;
+	char g_max;
+
+	char b_min;
+	char b_max;
+}gfx_colorkey;
+
+
+#define FB_NUMS		4
+
+typedef struct cnc_info
+{
+	struct {
+		struct fb_info *info;
+
+		/* framebuffer area */
+		unsigned long fb_base_phys;
+		unsigned long fb_base;
+		unsigned long fb_size;
+
+		/* to map the registers */
+		dma_addr_t    mmio_base_phys;
+		unsigned long mmio_base;
+		unsigned long mmio_size;
+		unsigned int  onoff;
+	} fbs_lst[FB_NUMS];
+
+	wait_queue_head_t vsync_wait;
+	unsigned long     vsync_cnt;
+	int timeout;
+	struct device *dev;
+}cncinfo;
+
+typedef struct _gfx_rect
+{
+	unsigned int startx;
+	unsigned int starty;
+	unsigned int endx;
+	unsigned int endy;
+}gfx_rect;
+
+/*
+ * Z-Order numbers are from hardware, don't redefine them!
+ */
+#define Z_ORDER_V0_V1_G         0x0123
+#define Z_ORDER_V0_G_V1         0x0213
+#define Z_ORDER_V1_V0_G         0x1023
+#define Z_ORDER_V1_G_V0         0x2013
+#define Z_ORDER_G_V0_V1         0x1203
+#define Z_ORDER_G_V1_V0         0x2103
+
+#define FBIO_GFX_ON             _IOW('F', 0x21, u_int32_t)
+#define FBIO_GFX_ALPHA          _IOW('F', 0x22, u_int32_t)
+#define FBIO_Z_ORDER            _IOW('F', 0x50, u_int32_t)
+#define FBIO_GFX_FLIP		    _IOW('F', 0x51, gfx2d_scalor_params)
+#define FBIO_GFX_COLORKEY_ON	_IOW('F', 0x52, u_int32_t)
+#define FBIO_GFX_COLORKEY_VAL	_IOW('F', 0x53, gfx_colorkey)
+#define FBIO_GFX_BGCOLOR	    _IOW('F', 0x54, u_int32_t)
+
+#define FBIO_GFX_OPAQUE_ONOFF    _IOW('F', 0x55, int)
+#define FBIO_GFX_CONFIG_DISTRECT    _IOW('F', 0x56, gfx_rect)
+#define FBIO_GFX_SET_UI_ENDIAN   _IOW('F', 0x57, u_int32_t)
+
+#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,49 @@
+
+config FB_CELESTIAL
+	tristate "Celestial CNC platform framebuffer support"
+	depends on FB && ARCH_CELESTIAL
+	select FB_CFB_FILLRECT
+	select FB_CFB_COPYAREA
+	select FB_CFB_IMAGEBLIT
+	help
+	  Frame buffer driver for the celestial platform.
+
+config FB0_SIZE
+	hex "Default size of frame buffer 0"
+	depends on FB_CELESTIAL
+	range 0x0 0x4000000
+	default "0x1000000"
+	help
+	    size of frame buffer 0, which is used for OSD Layer 0, frame buffer 2 is included in this buffer. range from 0x800000 to 0x1000000
+
+config FB2_SIZE
+	hex "Default size of frame buffer 2"
+	depends on FB_CELESTIAL
+	range 0x0 0x4000000
+	default "0x800000"
+	help
+	    size of frame buffer 2, it's included in frame buffer 0, set to half size of fb 0 is recommended. range from 0x400000 to 0x800000
+
+config FB1_SIZE
+	hex "Default size of frame buffer 1"
+	depends on FB_CELESTIAL
+	range 0x0 0x4000000
+	default "0x1000000"
+	help
+	    size of frame buffer 1, which is used for OSD Layer 1, frame buffer 3 is included in this buffer. range from 0x800000 to 0x1000000.
+
+config FB3_SIZE
+	hex "Default size of frame buffer 3"
+	depends on FB_CELESTIAL
+	range 0x0 0x4000000
+	default "0x800000"
+	help
+	    size of frame buffer 3, it's included in frame buffer 1, set to half size of fb 1 is recommended. range from 0x400000 to 0x800000.
+
+config ANDROID_FB0_ONLY
+       bool "android fb0 config"
+       depends on FB_CELESTIAL
+       default n
+       help
+          if this config been selected, will use another register configuration for ui1
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/video/celestial/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/celestial/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,23 @@
+#
+# Makefile for the Cavium Celestial SoC framebuffer device driver
+#
+
+
+
+
+ifdef CONFIG_ARCH_CELESTIAL 
+obj-y += cncfb.o 
+endif
+
+ifdef CONFIG_MACH_CELESTIAL_CNC1900
+obj-y +=cnc1900_fb_hw.o 
+endif
+
+ifdef CONFIG_MACH_CELESTIAL_CNC1800H
+obj-y +=cnc1800h_fb_hw.o 
+endif
+
+
+ifdef CONFIG_MACH_CELESTIAL_CNC1800L
+obj-y +=cnc1800l_fb_hw.o 
+endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/fbmem.c linux-linaro-3.4-2012.05-1_cavium/drivers/video/fbmem.c
--- linux-linaro-3.4-2012.05-1_original/drivers/video/fbmem.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/fbmem.c	2014-07-29 17:28:38.819972000 +0800
@@ -420,10 +420,16 @@
 {
 	unsigned int x;
 
+	unsigned int xoff,yoff;
+	xoff=(info->var.xres-num*(fb_logo.logo->width+8))>>1;
+	yoff=(info->var.yres-num*(fb_logo.logo->height+8))>>1;
 	if (rotate == FB_ROTATE_UR) {
 		for (x = 0;
 		     x < num && image->dx + image->width <= info->var.xres;
 		     x++) {
+                   image->dx=xoff;
+		     image->dy=yoff;
+				
 			info->fbops->fb_imageblit(info, image);
 			image->dx += image->width + 8;
 		}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/video/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/video/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -2374,6 +2374,7 @@
 	select FB_CFB_FILLRECT
 	select FB_CFB_COPYAREA
 	select FB_CFB_IMAGEBLIT
+	default y
 
 config FB_MX3
 	tristate "MX3 Framebuffer support"
@@ -2434,6 +2435,7 @@
 source "drivers/video/omap2/Kconfig"
 source "drivers/video/exynos/Kconfig"
 source "drivers/video/backlight/Kconfig"
+source "drivers/video/celestial/Kconfig"
 
 if VT
 	source "drivers/video/console/Kconfig"
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/video/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/video/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/video/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/video/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -147,7 +147,7 @@
 obj-$(CONFIG_FB_NUC900)           += nuc900fb.o
 obj-$(CONFIG_FB_JZ4740)		  += jz4740_fb.o
 obj-$(CONFIG_FB_PUV3_UNIGFX)      += fb-puv3.o
-
+obj-$(CONFIG_FB_CELESTIAL)        += celestial/
 # Platform or fallback drivers go here
 obj-$(CONFIG_FB_UVESA)            += uvesafb.o
 obj-$(CONFIG_FB_VESA)             += vesafb.o
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/watchdog/mpcore_wdt.c linux-linaro-3.4-2012.05-1_cavium/drivers/watchdog/mpcore_wdt.c
--- linux-linaro-3.4-2012.05-1_original/drivers/watchdog/mpcore_wdt.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/watchdog/mpcore_wdt.c	2014-07-29 17:28:38.819972000 +0800
@@ -38,6 +38,8 @@
 
 #include <asm/smp_twd.h>
 
+extern unsigned long twd_timer_rate;
+
 struct mpcore_wdt {
 	unsigned long	timer_alive;
 	struct device	*dev;
@@ -102,11 +104,8 @@
 
 	spin_lock(&wdt_lock);
 	/* Assume prescale is set to 256 */
-	count =  __raw_readl(wdt->base + TWD_WDOG_COUNTER);
-	count = (0xFFFFFFFFU - count) * (HZ / 5);
-	count = (count / 256) * mpcore_margin;
+	count = (twd_timer_rate / 256) * mpcore_margin;
 
-	/* Reload the counter */
 	writel(count + wdt->perturb, wdt->base + TWD_WDOG_LOAD);
 	wdt->perturb = wdt->perturb ? 0 : 1;
 	spin_unlock(&wdt_lock);
@@ -348,7 +347,7 @@
 	wdt->dev = &pdev->dev;
 	wdt->irq = platform_get_irq(pdev, 0);
 	if (wdt->irq >= 0) {
-		ret = devm_request_irq(wdt->dev, wdt->irq, mpcore_wdt_fire, 0,
+		ret = request_percpu_irq(wdt->irq, mpcore_wdt_fire,
 				"mpcore_wdt", wdt);
 		if (ret) {
 			dev_printk(KERN_ERR, wdt->dev,
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/exec.c linux-linaro-3.4-2012.05-1_cavium/fs/exec.c
--- linux-linaro-3.4-2012.05-1_original/fs/exec.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/exec.c	2014-07-29 17:28:38.819972000 +0800
@@ -787,7 +787,7 @@
 
 	fsnotify_open(file);
 
-	trace_open_exec(name);
+	trace_open_exec((char *)name);
 
 	err = deny_write_access(file);
 	if (err)
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/jffs2/erase.c linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/erase.c
--- linux-linaro-3.4-2012.05-1_original/fs/jffs2/erase.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/erase.c	2015-04-02 14:55:34.597802000 +0800
@@ -186,7 +186,12 @@
 {
 	/* For NAND, if the failure did not occur at the device level for a
 	   specific physical page, don't bother updating the bad block table. */
+
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+    if ((c->mtd->type == MTD_NANDFLASH) && (bad_offset != (uint32_t)MTD_FAIL_ADDR_UNKNOWN)) {
+#else
 	if (jffs2_cleanmarker_oob(c) && (bad_offset != (uint32_t)MTD_FAIL_ADDR_UNKNOWN)) {
+#endif
 		/* We had a device-level failure to erase.  Let's see if we've
 		   failed too many times. */
 		if (!jffs2_write_nand_badblock(c, jeb, bad_offset)) {
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/jffs2/fs.c linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/fs.c
--- linux-linaro-3.4-2012.05-1_original/fs/jffs2/fs.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/fs.c	2015-04-02 14:55:34.597802000 +0800
@@ -702,7 +702,11 @@
 static int jffs2_flash_setup(struct jffs2_sb_info *c) {
 	int ret = 0;
 
-	if (jffs2_cleanmarker_oob(c)) {
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+    if (c->mtd->type == MTD_NANDFLASH) {
+#else
+    if (jffs2_cleanmarker_oob(c)) {
+#endif
 		/* NAND flash... do setup accordingly */
 		ret = jffs2_nand_flash_setup(c);
 		if (ret)
@@ -735,7 +739,11 @@
 
 void jffs2_flash_cleanup(struct jffs2_sb_info *c) {
 
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+    if (c->mtd->type ==MTD_NANDFLASH) {
+#else
 	if (jffs2_cleanmarker_oob(c)) {
+#endif
 		jffs2_nand_flash_cleanup(c);
 	}
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/jffs2/Kconfig linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/Kconfig
--- linux-linaro-3.4-2012.05-1_original/fs/jffs2/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/Kconfig	2015-04-02 14:55:34.597802000 +0800
@@ -41,6 +41,13 @@
 	    - NOR flash with transparent ECC
 	    - DataFlash
 
+config JFFS2_NO_CLEANMARKER
+	bool "JFFS2 cleanmarker disabled (for BENAND or NAND with ECC builtin)"
+	depends on JFFS2_FS && JFFS2_FS_WRITEBUFFER
+	default n
+	help
+	  This disables the cleanmarker originally in the OOB area.
+
 config JFFS2_FS_WBUF_VERIFY
 	bool "Verify JFFS2 write-buffer reads"
 	depends on JFFS2_FS_WRITEBUFFER
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/jffs2/os-linux.h linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/os-linux.h
--- linux-linaro-3.4-2012.05-1_original/fs/jffs2/os-linux.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/os-linux.h	2015-04-02 14:55:34.597802000 +0800
@@ -106,7 +106,11 @@
 #define jffs2_can_mark_obsolete(c) (c->mtd->flags & (MTD_BIT_WRITEABLE))
 #endif
 
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+#define jffs2_cleanmarker_oob(c) (0)
+#else
 #define jffs2_cleanmarker_oob(c) (c->mtd->type == MTD_NANDFLASH)
+#endif
 
 #define jffs2_wbuf_dirty(c) (!!(c)->wbuf_len)
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/jffs2/scan.c linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/scan.c
--- linux-linaro-3.4-2012.05-1_original/fs/jffs2/scan.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/scan.c	2015-07-27 18:42:10.799681000 +0800
@@ -113,7 +113,11 @@
 	if (!flashbuf) {
 		/* For NAND it's quicker to read a whole eraseblock at a time,
 		   apparently */
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+		if (c->mtd->type == MTD_NANDFLASH)
+#else
 		if (jffs2_cleanmarker_oob(c))
+#endif
 			try_size = c->sector_size;
 		else
 			try_size = PAGE_SIZE;
@@ -459,7 +463,11 @@
 	jffs2_dbg(1, "%s(): Scanning block at 0x%x\n", __func__, ofs);
 
 #ifdef CONFIG_JFFS2_FS_WRITEBUFFER
-	if (jffs2_cleanmarker_oob(c)) {
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+		if (c->mtd->type == MTD_NANDFLASH) {
+#else
+		if (jffs2_cleanmarker_oob(c)) {
+#endif
 		int ret;
 
 		if (mtd_block_isbad(c->mtd, jeb->offset))
@@ -565,7 +573,11 @@
 
 	if (ofs == max_ofs) {
 #ifdef CONFIG_JFFS2_FS_WRITEBUFFER
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+		if (c->mtd->type == MTD_NANDFLASH) {
+#else
 		if (jffs2_cleanmarker_oob(c)) {
+#endif
 			/* scan oob, take care of cleanmarker */
 			int ret = jffs2_check_oob_empty(c, jeb, cleanmarkerfound);
 			jffs2_dbg(2, "jffs2_check_oob_empty returned %d\n",
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/jffs2/wbuf.c linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/wbuf.c
--- linux-linaro-3.4-2012.05-1_original/fs/jffs2/wbuf.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/jffs2/wbuf.c	2015-07-28 17:17:26.969575000 +0800
@@ -1076,7 +1076,11 @@
 				 struct jffs2_eraseblock *jeb)
 {
 	struct mtd_oob_ops ops;
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+	int i, ret, cmlen = min_t(int, c->oobavail, OOB_CM_SIZE);
+#else
 	int ret, cmlen = min_t(int, c->oobavail, OOB_CM_SIZE);
+#endif
 
 	ops.mode = MTD_OPS_AUTO_OOB;
 	ops.ooblen = cmlen;
@@ -1092,8 +1096,24 @@
 			ret = -EIO;
 		return ret;
 	}
-
+#ifdef CONFIG_JFFS2_NO_CLEANMARKER
+	if (jffs2_cleanmarker_oob(c))
+		return !!memcmp(&oob_cleanmarker, c->oobbuf, cmlen);
+	else
+	{
+		for(i = 0; i < cmlen; i++) {
+			if (ops.oobbuf[i] != 0xFF) {
+				jffs2_dbg(2, "Found dirty data %02x at %x in OOB for "
+					"%08x\n", ops.oobbuf[i], i, jeb->offset);
+				return 1;
+			}
+		}
+		return 0;
+	}
+#else
 	return !!memcmp(&oob_cleanmarker, c->oobbuf, cmlen);
+#endif
+
 }
 
 int jffs2_write_nand_cleanmarker(struct jffs2_sb_info *c,
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/seq_file.c linux-linaro-3.4-2012.05-1_cavium/fs/seq_file.c
--- linux-linaro-3.4-2012.05-1_original/fs/seq_file.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/seq_file.c	2014-07-29 17:28:38.819972000 +0800
@@ -78,6 +78,29 @@
 }
 EXPORT_SYMBOL(seq_open);
 
+#ifdef CONFIG_PUREVU
+/*
+ * A single seq_printf(), seq_puts(), ... can't be bigger than SEQ_GUARDBAND
+ * for this to prevent overflow 
+ */
+#define SEQ_GUARDBAND (PAGE_SIZE>>2)
+static void attempt_to_prevent_overflow(struct seq_file *m)
+{
+	/* Attempt to prevent overflow, unless it is too late (count==size) */
+	if ((m->count != m->size) && (m->count + SEQ_GUARDBAND >= m->size)) {
+		char *bigger_buf = kmalloc(m->size << 1, GFP_KERNEL);
+		if (bigger_buf) {
+			memcpy(bigger_buf, m->buf, m->size);
+			kfree(m->buf);
+			m->buf = bigger_buf;
+			m->size <<= 1;
+		}
+	/* NOTE: even if we can't get the bigger buf, just keep trying
+	 * with the smaller one */
+	}
+}
+#endif
+
 static int traverse(struct seq_file *m, loff_t offset)
 {
 	loff_t pos = 0, index;
@@ -390,6 +413,9 @@
 	va_list args;
 	int len;
 
+#ifdef CONFIG_PUREVU
+	attempt_to_prevent_overflow(m);
+#endif
 	if (m->count < m->size) {
 		va_start(args, f);
 		len = vsnprintf(m->buf + m->count, m->size - m->count, f, args);
@@ -639,6 +665,9 @@
 
 int seq_putc(struct seq_file *m, char c)
 {
+#ifdef CONFIG_PUREVU
+	attempt_to_prevent_overflow(m);
+#endif
 	if (m->count < m->size) {
 		m->buf[m->count++] = c;
 		return 0;
@@ -650,6 +679,9 @@
 int seq_puts(struct seq_file *m, const char *s)
 {
 	int len = strlen(s);
+#ifdef CONFIG_PUREVU
+	attempt_to_prevent_overflow(m);
+#endif
 	if (m->count + len < m->size) {
 		memcpy(m->buf + m->count, s, len);
 		m->count += len;
@@ -722,6 +754,9 @@
  */
 int seq_write(struct seq_file *seq, const void *data, size_t len)
 {
+#ifdef CONFIG_PUREVU
+	attempt_to_prevent_overflow(seq);
+#endif
 	if (seq->count + len < seq->size) {
 		memcpy(seq->buf + seq->count, data, len);
 		seq->count += len;
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/yaffs2/Kconfig linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/Kconfig
--- linux-linaro-3.4-2012.05-1_original/fs/yaffs2/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -1,161 +1,30 @@
 #
-# YAFFS file system configurations
+# yaffs file system configurations
 #
 
 config YAFFS_FS
-	tristate "YAFFS2 file system support"
+	tristate "yaffs2 file system support"
 	default n
 	depends on MTD_BLOCK
 	select YAFFS_YAFFS1
 	select YAFFS_YAFFS2
 	help
-	  YAFFS2, or Yet Another Flash Filing System, is a filing system
+	  yaffs2, or Yet Another Flash File System, is a file system
 	  optimised for NAND Flash chips.
 
-	  To compile the YAFFS2 file system support as a module, choose M
+	  To compile the yaffs2 file system support as a module, choose M
 	  here: the module will be called yaffs2.
 
 	  If unsure, say N.
 
-	  Further information on YAFFS2 is available at
+	  Further information on yaffs2 is available at
 	  <http://www.aleph1.co.uk/yaffs/>.
 
-config YAFFS_YAFFS1
-	bool "512 byte / page devices"
-	depends on YAFFS_FS
-	default y
-	help
-	  Enable YAFFS1 support -- yaffs for 512 byte / page devices
-
-	  Not needed for 2K-page devices.
-
-	  If unsure, say Y.
-
-config YAFFS_9BYTE_TAGS
-	bool "Use older-style on-NAND data format with pageStatus byte"
-	depends on YAFFS_YAFFS1
-	default n
-	help
-
-	  Older-style on-NAND data format has a "pageStatus" byte to record
-	  chunk/page state.  This byte is zero when the page is discarded.
-	  Choose this option if you have existing on-NAND data using this
-	  format that you need to continue to support.  New data written
-	  also uses the older-style format.  Note: Use of this option
-	  generally requires that MTD's oob layout be adjusted to use the
-	  older-style format.  See notes on tags formats and MTD versions
-	  in yaffs_mtdif1.c.
-
-	  If unsure, say N.
-
-config YAFFS_DOES_ECC
-	bool "Lets Yaffs do its own ECC"
-	depends on YAFFS_FS && YAFFS_YAFFS1 && !YAFFS_9BYTE_TAGS
-	default n
-	help
-	  This enables Yaffs to use its own ECC functions instead of using
-	  the ones from the generic MTD-NAND driver.
-
-	  If unsure, say N.
-
-config YAFFS_ECC_WRONG_ORDER
-	bool "Use the same ecc byte order as Steven Hill's nand_ecc.c"
-	depends on YAFFS_FS && YAFFS_DOES_ECC && !YAFFS_9BYTE_TAGS
-	default n
-	help
-	  This makes yaffs_ecc.c use the same ecc byte order as Steven
-	  Hill's nand_ecc.c. If not set, then you get the same ecc byte
-	  order as SmartMedia.
-
-	  If unsure, say N.
-
-config YAFFS_YAFFS2
-	bool "2048 byte (or larger) / page devices"
-	depends on YAFFS_FS
-	default y
-	help
-	  Enable YAFFS2 support -- yaffs for >= 2K bytes per page devices
-
-	  If unsure, say Y.
-
-config YAFFS_AUTO_YAFFS2
-	bool "Autoselect yaffs2 format"
-	depends on YAFFS_YAFFS2
-	default y
-	help
-	  Without this, you need to explicitely use yaffs2 as the file
-	  system type. With this, you can say "yaffs" and yaffs or yaffs2
-	  will be used depending on the device page size (yaffs on
-	  512-byte page devices, yaffs2 on 2K page devices).
-
-	  If unsure, say Y.
-
-config YAFFS_DISABLE_TAGS_ECC
-	bool "Disable YAFFS from doing ECC on tags by default"
-	depends on YAFFS_FS && YAFFS_YAFFS2
-	default n
-	help
-	  This defaults Yaffs to using its own ECC calculations on tags instead of
-	  just relying on the MTD.
-	  This behavior can also be overridden with tags_ecc_on and
-	  tags_ecc_off mount options.
-
-	  If unsure, say N.
-
-config YAFFS_ALWAYS_CHECK_CHUNK_ERASED
-	bool "Force chunk erase check"
-	depends on YAFFS_FS
-	default n
-	help
-          Normally YAFFS only checks chunks before writing until an erased
-	  chunk is found. This helps to detect any partially written
-	  chunks that might have happened due to power loss.
-
-	  Enabling this forces on the test that chunks are erased in flash
-	  before writing to them. This takes more time but is potentially
-	  a bit more secure.
-
-	  Suggest setting Y during development and ironing out driver
-	  issues etc. Suggest setting to N if you want faster writing.
-
-	  If unsure, say Y.
-
-config YAFFS_EMPTY_LOST_AND_FOUND
-	bool "Empty lost and found on boot"
-	depends on YAFFS_FS
-	default n
-	help
-	  If this is enabled then the contents of lost and found is
-	  automatically dumped at mount.
-
-	  If unsure, say N.
-
-config YAFFS_DISABLE_BLOCK_REFRESHING
-	bool "Disable yaffs2 block refreshing"
+config YAFFS_DEBUG
+	bool "Enable yaffs debugging"
 	depends on YAFFS_FS
 	default n
 	help
-	 If this is set, then block refreshing is disabled.
-	 Block refreshing infrequently refreshes the oldest block in
-	 a yaffs2 file system. This mechanism helps to refresh flash to
-	 mitigate against data loss. This is particularly useful for MLC.
+	  Enable the yaffs debugging tracing.
 
 	  If unsure, say N.
-
-config YAFFS_DISABLE_BACKGROUND
-	bool "Disable yaffs2 background processing"
-	depends on YAFFS_FS
-	default n
-	help
-	 If this is set, then background processing is disabled.
-	 Background processing makes many foreground activities faster.
-
-	 If unsure, say N.
-
-config YAFFS_XATTR
-	bool "Enable yaffs2 xattr support"
-	depends on YAFFS_FS
-	default y
-	help
-	 If this is set then yaffs2 will provide xattr support.
-	 If unsure, say Y.
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/yaffs2/Makefile linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/Makefile
--- linux-linaro-3.4-2012.05-1_original/fs/yaffs2/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -6,12 +6,13 @@
 
 yaffs-y := yaffs_ecc.o yaffs_vfs.o yaffs_guts.o yaffs_checkptrw.o
 yaffs-y += yaffs_packedtags1.o yaffs_packedtags2.o yaffs_nand.o
-yaffs-y += yaffs_tagscompat.o yaffs_tagsvalidity.o
+yaffs-y += yaffs_tagscompat.o
 yaffs-y += yaffs_mtdif.o yaffs_mtdif1.o yaffs_mtdif2.o
 yaffs-y += yaffs_nameval.o yaffs_attribs.o
 yaffs-y += yaffs_allocator.o
 yaffs-y += yaffs_yaffs1.o
 yaffs-y += yaffs_yaffs2.o
 yaffs-y += yaffs_bitmap.o
+yaffs-y += yaffs_summary.o
 yaffs-y += yaffs_verify.o
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/yaffs2/yaffs_allocator.c linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/yaffs_allocator.c
--- linux-linaro-3.4-2012.05-1_original/fs/yaffs2/yaffs_allocator.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/yaffs_allocator.c	2014-07-29 17:28:38.819972000 +0800
@@ -1,7 +1,7 @@
 /*
  * YAFFS: Yet Another Flash File System. A NAND-flash specific file system.
  *
- * Copyright (C) 2002-2010 Aleph One Ltd.
+ * Copyright (C) 2002-2011 Aleph One Ltd.
  *   for Toby Churchill Ltd and Brightstar Engineering
  *
  * Created by Charles Manning <charles@aleph1.co.uk>
@@ -16,53 +16,19 @@
 #include "yaffs_trace.h"
 #include "yportenv.h"
 
-#ifdef CONFIG_YAFFS_KMALLOC_ALLOCATOR
-
-void yaffs_deinit_raw_tnodes_and_objs(struct yaffs_dev *dev)
-{
-	dev = dev;
-}
-
-void yaffs_init_raw_tnodes_and_objs(struct yaffs_dev *dev)
-{
-	dev = dev;
-}
-
-struct yaffs_tnode *yaffs_alloc_raw_tnode(struct yaffs_dev *dev)
-{
-	return (struct yaffs_tnode *)kmalloc(dev->tnode_size, GFP_NOFS);
-}
-
-void yaffs_free_raw_tnode(struct yaffs_dev *dev, struct yaffs_tnode *tn)
-{
-	dev = dev;
-	kfree(tn);
-}
-
-void yaffs_init_raw_objs(struct yaffs_dev *dev)
-{
-	dev = dev;
-}
-
-void yaffs_deinit_raw_objs(struct yaffs_dev *dev)
-{
-	dev = dev;
-}
-
-struct yaffs_obj *yaffs_alloc_raw_obj(struct yaffs_dev *dev)
-{
-	dev = dev;
-	return (struct yaffs_obj *)kmalloc(sizeof(struct yaffs_obj));
-}
-
-void yaffs_free_raw_obj(struct yaffs_dev *dev, struct yaffs_obj *obj)
-{
-
-	dev = dev;
-	kfree(obj);
-}
-
-#else
+/*
+ * Each entry in yaffs_tnode_list and yaffs_obj_list hold blocks
+ * of approx 100 objects that are themn allocated singly.
+ * This is basically a simplified slab allocator.
+ *
+ * We don't use the Linux slab allocator because slab does not allow
+ * us to dump all the objects in one hit when we do a umount and tear
+ * down  all the tnodes and objects. slab requires that we first free
+ * the individual objects.
+ *
+ * Once yaffs has been mainlined I shall try to motivate for a change
+ * to slab to provide the extra features we need here.
+ */
 
 struct yaffs_tnode_list {
 	struct yaffs_tnode_list *next;
@@ -81,7 +47,7 @@
 	struct yaffs_tnode_list *alloc_tnode_list;
 
 	int n_obj_created;
-	struct yaffs_obj *free_objs;
+	struct list_head free_objs;
 	int n_free_objects;
 
 	struct yaffs_obj_list *allocated_obj_list;
@@ -89,14 +55,12 @@
 
 static void yaffs_deinit_raw_tnodes(struct yaffs_dev *dev)
 {
-
 	struct yaffs_allocator *allocator =
 	    (struct yaffs_allocator *)dev->allocator;
-
 	struct yaffs_tnode_list *tmp;
 
 	if (!allocator) {
-		YBUG();
+		BUG();
 		return;
 	}
 
@@ -106,7 +70,6 @@
 		kfree(allocator->alloc_tnode_list->tnodes);
 		kfree(allocator->alloc_tnode_list);
 		allocator->alloc_tnode_list = tmp;
-
 	}
 
 	allocator->free_tnodes = NULL;
@@ -118,14 +81,15 @@
 {
 	struct yaffs_allocator *allocator = dev->allocator;
 
-	if (allocator) {
-		allocator->alloc_tnode_list = NULL;
-		allocator->free_tnodes = NULL;
-		allocator->n_free_tnodes = 0;
-		allocator->n_tnodes_created = 0;
-	} else {
-		YBUG();
+	if (!allocator) {
+		BUG();
+		return;
 	}
+
+	allocator->alloc_tnode_list = NULL;
+	allocator->free_tnodes = NULL;
+	allocator->n_free_tnodes = 0;
+	allocator->n_tnodes_created = 0;
 }
 
 static int yaffs_create_tnodes(struct yaffs_dev *dev, int n_tnodes)
@@ -140,7 +104,7 @@
 	struct yaffs_tnode_list *tnl;
 
 	if (!allocator) {
-		YBUG();
+		BUG();
 		return YAFFS_FAIL;
 	}
 
@@ -148,7 +112,6 @@
 		return YAFFS_OK;
 
 	/* make these things */
-
 	new_tnodes = kmalloc(n_tnodes * dev->tnode_size, GFP_NOFS);
 	mem = (u8 *) new_tnodes;
 
@@ -176,7 +139,6 @@
 	 * NB If we can't add this to the management list it isn't fatal
 	 * but it just means we can't free this bunch of tnodes later.
 	 */
-
 	tnl = kmalloc(sizeof(struct yaffs_tnode_list), GFP_NOFS);
 	if (!tnl) {
 		yaffs_trace(YAFFS_TRACE_ERROR,
@@ -188,7 +150,7 @@
 		allocator->alloc_tnode_list = tnl;
 	}
 
-	yaffs_trace(YAFFS_TRACE_ALLOCATE,"Tnodes added");
+	yaffs_trace(YAFFS_TRACE_ALLOCATE, "Tnodes added");
 
 	return YAFFS_OK;
 }
@@ -200,7 +162,7 @@
 	struct yaffs_tnode *tn = NULL;
 
 	if (!allocator) {
-		YBUG();
+		BUG();
 		return NULL;
 	}
 
@@ -223,7 +185,7 @@
 	struct yaffs_allocator *allocator = dev->allocator;
 
 	if (!allocator) {
-		YBUG();
+		BUG();
 		return;
 	}
 
@@ -235,17 +197,24 @@
 	dev->checkpoint_blocks_required = 0;	/* force recalculation */
 }
 
+/*--------------- yaffs_obj alloaction ------------------------
+ *
+ * Free yaffs_objs are stored in a list using obj->siblings.
+ * The blocks of allocated objects are stored in a linked list.
+ */
+
 static void yaffs_init_raw_objs(struct yaffs_dev *dev)
 {
 	struct yaffs_allocator *allocator = dev->allocator;
 
-	if (allocator) {
-		allocator->allocated_obj_list = NULL;
-		allocator->free_objs = NULL;
-		allocator->n_free_objects = 0;
-	} else {
-		YBUG();
+	if (!allocator) {
+		BUG();
+		return;
 	}
+
+	allocator->allocated_obj_list = NULL;
+	INIT_LIST_HEAD(&allocator->free_objs);
+	allocator->n_free_objects = 0;
 }
 
 static void yaffs_deinit_raw_objs(struct yaffs_dev *dev)
@@ -254,7 +223,7 @@
 	struct yaffs_obj_list *tmp;
 
 	if (!allocator) {
-		YBUG();
+		BUG();
 		return;
 	}
 
@@ -262,11 +231,10 @@
 		tmp = allocator->allocated_obj_list->next;
 		kfree(allocator->allocated_obj_list->objects);
 		kfree(allocator->allocated_obj_list);
-
 		allocator->allocated_obj_list = tmp;
 	}
 
-	allocator->free_objs = NULL;
+	INIT_LIST_HEAD(&allocator->free_objs);
 	allocator->n_free_objects = 0;
 	allocator->n_obj_created = 0;
 }
@@ -274,13 +242,12 @@
 static int yaffs_create_free_objs(struct yaffs_dev *dev, int n_obj)
 {
 	struct yaffs_allocator *allocator = dev->allocator;
-
 	int i;
 	struct yaffs_obj *new_objs;
 	struct yaffs_obj_list *list;
 
 	if (!allocator) {
-		YBUG();
+		BUG();
 		return YAFFS_FAIL;
 	}
 
@@ -292,27 +259,19 @@
 	list = kmalloc(sizeof(struct yaffs_obj_list), GFP_NOFS);
 
 	if (!new_objs || !list) {
-		if (new_objs) {
-			kfree(new_objs);
-			new_objs = NULL;
-		}
-		if (list) {
-			kfree(list);
-			list = NULL;
-		}
+		kfree(new_objs);
+		new_objs = NULL;
+		kfree(list);
+		list = NULL;
 		yaffs_trace(YAFFS_TRACE_ALLOCATE,
 			"Could not allocate more objects");
 		return YAFFS_FAIL;
 	}
 
 	/* Hook them into the free list */
-	for (i = 0; i < n_obj - 1; i++) {
-		new_objs[i].siblings.next =
-		    (struct list_head *)(&new_objs[i + 1]);
-	}
+	for (i = 0; i < n_obj; i++)
+		list_add(&new_objs[i].siblings, &allocator->free_objs);
 
-	new_objs[n_obj - 1].siblings.next = (void *)allocator->free_objs;
-	allocator->free_objs = new_objs;
 	allocator->n_free_objects += n_obj;
 	allocator->n_obj_created += n_obj;
 
@@ -328,21 +287,22 @@
 struct yaffs_obj *yaffs_alloc_raw_obj(struct yaffs_dev *dev)
 {
 	struct yaffs_obj *obj = NULL;
+	struct list_head *lh;
 	struct yaffs_allocator *allocator = dev->allocator;
 
 	if (!allocator) {
-		YBUG();
+		BUG();
 		return obj;
 	}
 
 	/* If there are none left make more */
-	if (!allocator->free_objs)
+	if (list_empty(&allocator->free_objs))
 		yaffs_create_free_objs(dev, YAFFS_ALLOCATION_NOBJECTS);
 
-	if (allocator->free_objs) {
-		obj = allocator->free_objs;
-		allocator->free_objs =
-		    (struct yaffs_obj *)(allocator->free_objs->siblings.next);
+	if (!list_empty(&allocator->free_objs)) {
+		lh = allocator->free_objs.next;
+		obj = list_entry(lh, struct yaffs_obj, siblings);
+		list_del_init(lh);
 		allocator->n_free_objects--;
 	}
 
@@ -354,43 +314,44 @@
 
 	struct yaffs_allocator *allocator = dev->allocator;
 
-	if (!allocator)
-		YBUG();
-	else {
-		/* Link into the free list. */
-		obj->siblings.next = (struct list_head *)(allocator->free_objs);
-		allocator->free_objs = obj;
-		allocator->n_free_objects++;
+	if (!allocator) {
+		BUG();
+		return;
 	}
+
+	/* Link into the free list. */
+	list_add(&obj->siblings, &allocator->free_objs);
+	allocator->n_free_objects++;
 }
 
 void yaffs_deinit_raw_tnodes_and_objs(struct yaffs_dev *dev)
 {
-	if (dev->allocator) {
-		yaffs_deinit_raw_tnodes(dev);
-		yaffs_deinit_raw_objs(dev);
 
-		kfree(dev->allocator);
-		dev->allocator = NULL;
-	} else {
-		YBUG();
+	if (!dev->allocator) {
+		BUG();
+		return;
 	}
+
+	yaffs_deinit_raw_tnodes(dev);
+	yaffs_deinit_raw_objs(dev);
+	kfree(dev->allocator);
+	dev->allocator = NULL;
 }
 
 void yaffs_init_raw_tnodes_and_objs(struct yaffs_dev *dev)
 {
 	struct yaffs_allocator *allocator;
 
-	if (!dev->allocator) {
-		allocator = kmalloc(sizeof(struct yaffs_allocator), GFP_NOFS);
-		if (allocator) {
-			dev->allocator = allocator;
-			yaffs_init_raw_tnodes(dev);
-			yaffs_init_raw_objs(dev);
-		}
-	} else {
-		YBUG();
+	if (dev->allocator) {
+		BUG();
+		return;
+	}
+
+	allocator = kmalloc(sizeof(struct yaffs_allocator), GFP_NOFS);
+	if (allocator) {
+		dev->allocator = allocator;
+		yaffs_init_raw_tnodes(dev);
+		yaffs_init_raw_objs(dev);
 	}
 }
 
-#endif
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/yaffs2/yaffs_allocator.h linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/yaffs_allocator.h
